from blog_config import *
import Cookie
import psycopg
import blog
import blog_config
import cgi
import os
import re
import db_row
import trackback
import urllib2
import urlutils
import urlparse

from blog import make_select, make_checked, create_checkbox

def edit_form(entry, db, eid=None, preview=False, textile=False,
              updatemod=False, wlping=True, ping=True, manualtb='',
              tlist=None, best=False):
    cursor = db.cursor()
    cursor.execute('SELECT author,authorname FROM authors ORDER BY authorname')
    authors = cursor.fetchall()

    cursor.execute('SELECT topic, topicname FROM topics ORDER BY topicname')
    topics = cursor.fetchall()

    auth = entry.get('author')
    if not auth and os.environ.get('REMOTE_USER'):
        cursor.execute('SELECT author FROM authors WHERE '
                       'login=%(REMOTE_USER)s', os.environ)
        auth = cursor.fetchone()[0]

    print '<div class="blog-stuff">'
    if preview:
        print '<div class="blog-entry">'
        print '<div class="blog-header"><span class="author-%d">%s</span></div>' % (auth or 0, entry.get('title', ''))
        if entry.get('extended'):
            print '<div class="blog-content">%s<hr /><div>%s</div></div>' % (entry.get('body', ''), entry.get('extended', ''))
        else:
            print '<div class="blog-content">%s</div>' % entry.get('body', '')

        print '<div class="blog-footer">'
        if tlist:
            twords = []
            for tnum, tname in topics:
                if tnum in tlist:
                    twords.append(tname)
            print '(%s)' % '/'.join(twords)
        print '</div>'
        print '</div>'
        print '<h2>Edit this entry</h2>'

    print '<form action="%s" method="post" enctype="multipart/form-data" accept-charset="utf-8 ascii" accept="text/html,text/plain">' % MODURL
    if eid:
        print '<input type="hidden" name="entryid" value="%d" />' % eid

    print '<label accesskey="T">Title: <input type="text" name="title" value="%s" size="60" /></label><br />' % cgi.escape(entry.get('title', ''), 1)
    print '<label><textarea name="body" rows="12" cols="80">'
    body = entry.get('body')
    if body:
        body = re.sub(r'&(lt|gt|quo);', r'&amp;\1;', body)
        print body+'</textarea></label><br />'
    else:
        print '</textarea></label><br />'

    extended = entry.get('extended')
    print '<label>Extended body (OPTIONAL&mdash;appears under &ldquo;Read more...&rdquo;):<br /><textarea name="extended" rows="8" cols="80">'
    if extended:
        extended = re.sub(r'&(lt|gt|quo);', r'&amp;\1;', extended)
        print extended+'</textarea></label><br />'
    else:
        print '</textarea></label><br />'

    excerpt = entry.get('excerpt')
    print '<label>Excerpt (OPTIONAL&mdash;text only; sent to Trackbacks and used in the RSS feed):<br /><textarea name="excerpt" rows="8" cols="80">'
    if excerpt:
        excerpt = re.sub(r'&(lt|gt|quo);', r'&amp;\1;', excerpt)
        print excerpt+'</textarea></label><br />'
    else:
        print '</textarea></label><br />'

    if eid is None:
        print '<label accesskey="U">Upload body from file: <input name="upload" type="file" /></label><br />'

    print create_checkbox('visible', 'Visible.', 'V', entry.get('visible'))
    print create_checkbox('ping', 'Autodiscover trackback <span class="caps">URL</span>s.', 'T', ping)
    print '<label accesskey="M">Manual trackback URL: <input type="text" name="manualtb" size="60" value="%s" /></label><br />' % manualtb
    print create_checkbox('wlping', 'Ping weblogs.com and blo.gs.', 'P', wlping)
    print create_checkbox('textile', 'Process body with <a href="http://diveintomark.org/projects/pytextile/">PyTextile</a>.', 'X', textile)
    print create_checkbox('pinned', 'Pin entry to top of front page.', 'I', entry.get('pinned'))
    print create_checkbox('best', 'Best of the blog.', 'B', best)
    if eid is not None:
        print create_checkbox('updatemod', 'Update last modified time for this entry.', 'U', updatemod)
        print create_checkbox('delete', 'Delete this entry.', 'D', False)
    print '<label accesskey="A">Author: '+make_select('author', authors, auth)
    print '</label> <a href="%s?newauthor=1">[New Author]</a><br />' % EDITURL
    print '<label accesskey="T">Topic(s): '+make_select('topic', topics, tlist, multiple=True)
    print '</label> <a href="%s?newtopic=1">[New Topic]</a><br />' % EDITURL
    print '<input type="submit" name="preview" value="Preview" />'
    print '<input type="submit" name="submit" value="Submit" />'
    print '</form>'
    print '</div>'

FIELDMAP = (
    ('name', 'Name'), ('url', 'URL'), ('comment', 'Comment'),
    ('rssurl', 'RSS feed URL'), ('foafurl', 'FOAF URL')
    )

def blogroll_interface(req=None, cookies=None):
    db = psycopg.connect(DSN)
    cursor = db.cursor()

    cursor.execute("SELECT oid, name, url, comment, updated, "
                   "COALESCE(rssurl, '') AS rssurl, "
                   "COALESCE(foafurl, '') AS foafurl "
                   "FROM blogroll ORDER BY lower(name)")
    R = db_row.MetaRow(cursor.description)
    entries = [R(row) for row in cursor.fetchall()]

    try:
        use_style = cookies['style'].value
    except:
        use_style = blog_config.DEF_STYLESHEET
    blog.header(BLOG_TITLE+": Blogroll admin interface", req=req,
                use_style=use_style)
    print '<div class="blog-stuff">'
    print '<p><a href="%s">[Post Admin]</a>' % ADMINURL
    print '<a href="#addform">[Add New Blogroll Entry]</a>'
    print '<a href="%s">[BlogFront]</a></p>' % URL
    print '<input type="hidden" name="blogroll" value="1" />'
    print '<table class="admin"><tr class="admin-top"><th>Name</th><th>URL</th><th>Comment</th><th colspan="2">Controls</th></tr>'
    for entry in entries:
        bits = {}
        bits.update(entry)
        for item in ('name', 'url', 'comment'):
            bits[item] = cgi.escape(entry.get(item, ''), 1)

        print '<tr><td>%s</td><td>%s</td><td>%s</td>' % (
            entry.fields.name, entry.fields.url, entry.fields.comment)
        print '<form action="%s" method="get">' % ADMINURL
        print '<td><input type="hidden" name="blogroll" value="1" />'
        print '<input type="hidden" name="name" value="%s" />' % bits['name']
        print '<input type="hidden" name="url" value="%s" />' % bits['url']
        print '<input type="submit" name="edit" value="Edit" /></td>'
        print '</form>'
        print '<form action="%s" method="post">' % MODURL
        print '<td><input type="hidden" name="blogroll" value="1" />'
        print '<input type="submit" name="delete-%d" value="Delete" /></td>' % entry.fields.oid
        print '</form>'
        print '</tr>'
    print '</table>'

    print '<form id="addform" action="%s" method="post">' % MODURL
    print '<table border="0">'
    for field, desc in FIELDMAP:
        print '<tr><td><label for="%s">%s:</label></td><td><input name="%s" value="" size="60" /></td></tr>' % (field, desc, field)
    print '</table>'
    print '<input type="hidden" name="blogroll" value="1" />'
    print '<input type="submit" name="add" value="Add new entry" />'
    print '</form>'

    print '</div>'

    blog.footer()
    return

def blogroll_edit_entry(name, url, req=None, cookies=None):
    db = psycopg.connect(DSN)
    cursor = db.cursor()

    cursor.execute("SELECT oid, name, url, comment, updated, "
                   "COALESCE(rssurl, '') AS rssurl, "
                   "COALESCE(foafurl, '') AS foafurl "
                   "FROM blogroll WHERE name=%(name)s AND url=%(url)s",
                   {'name' : name, 'url' : url})
    if not cursor.rowcount:
        return blogroll_interface(req, cookies)

    R = db_row.MetaRow(cursor.description)
    entry = R(cursor.fetchone())

    try:
        use_style = cookies['style'].value
    except:
        use_style = blog_config.DEF_STYLESHEET

    oid = entry.fields.oid
    blog.header(BLOG_TITLE+": Edit blogroll entry", req=req,
                use_style=use_style)
    print '<div class="blog-stuff">'
    print '<p><a href="%s">[Post Admin]</a>' % ADMINURL
    print '<a href="%s?blogroll=1">[Blogroll Admin]</a>' % ADMINURL
    print '<a href="%s">[BlogFront]</a></p>' % URL
    print '<form action="%s" method="post">' % MODURL
    print '<input type="hidden" name="blogroll" value="1" />'
    print '<table border="0">'
    for (field, desc) in FIELDMAP:
        print '<tr><td><label for="%s-%d">%s:</label></td><td><input name="%s-%d" value="%s" size="60" /></td></tr>' % (field, oid, desc, field, oid, cgi.escape(entry[field], 1))
    print '</table>'
    print '<input type="submit" name="save" value="Save changes" />'
    print '</form>'
    print '</div>'

    blog.footer()
    return

def admin_interface(offset=0, limit=20, blogroll=0, name='', url='',
                    req=None, cookies=None):
    if blogroll:
        #print 'Content-type: text/plain\n'
        #print repr(name), repr(url)

        if name and url:
            return blogroll_edit_entry(name, url, req, cookies)
        return blogroll_interface(req, cookies)

    db = psycopg.connect(DSN)
    cursor = db.cursor()
    cursor.execute('SELECT COUNT(*) FROM content')
    count = cursor.fetchone()[0]

    cursor.execute('SELECT entryid, title, date, lastmod, visible, c.author, authorname FROM content c, authors a WHERE c.author=a.author ORDER BY entryid DESC LIMIT %d OFFSET %d' % (limit, offset))
    R = db_row.MetaRow(cursor.description)
    entries = [R(row) for row in cursor.fetchall()]

    eidlist = [e.fields.entryid for e in entries]

    tbcount = {}
    pings = {}
    if eidlist:
        for entry in eidlist:
            cursor.execute('SELECT COUNT(*) FROM trackback WHERE entryid=%d' %
                           entry)
            tbcount[entry] = cursor.fetchone()[0]
            cursor.execute('SELECT COUNT(*) FROM pinged WHERE entryid=%d' %
                           entry)
            pings[entry] = cursor.fetchone()[0]

    try:
        use_style = cookies['style'].value
    except:
        use_style = blog_config.DEF_STYLESHEET

    blog.header(BLOG_TITLE+": Administrative interface", req=req,
                use_style=use_style)
    print '<div class="blog-stuff">'
    print '<p><a href="%s">[New Post]</a>' % EDITURL
    print '<a href="%s?newauthor=1">[New Author]</a>' % EDITURL
    print '<a href="%s?newtopic=1">[New Topic]</a>' % EDITURL
    print '<a href="%s?blogroll=1">[Edit Blogroll]</a>' % ADMINURL
    print '<a title="Bookmark this link in your browser for a quick way to post an entry pointing to a given page or post." href="javascript:location.href=\'%s?url=\'+escape(location.href)">[Link and Post Bookmarklet]</a>' % urlparse.urljoin(URL, LINKPOSTURL)

    print '<a href="%s">[BlogFront]</a><br />' % URL
    if offset > 0:
        newoffset = max(offset-limit, 0)
        print '<a accesskey="N" href="%s?offset=%d&limit=%d" class="blog-nav-backward" rev="next" rel="prev">&laquo; Newer Entries</a>' % (ADMINURL, newoffset, limit)
    if (offset+limit) < count:
        print '<a accesskey="O" href="%s?offset=%d&limit=%d" class="blog-nav-forward" rev="prev" rel="next">Older Entries &raquo;</a>' % (ADMINURL, offset+limit, limit)
    print '</p>'

    print '<table class="admin" width="100%"><tr class="admin-top"><th>ID</th><th>Title</th><th>Trackbacks</th><th>Author</th><th>Date</th><th>Modified</th></tr>'
    for entry in entries:
        eid = entry.fields.entryid
        datestr = entry['date'].strftime('%F %R')
        lmstr = entry['lastmod'].strftime('%F %R')
        print '<tr><td>%d</td>' % entry['entryid']
        print '<td>'
        if entry['visible']:
            style = ''
        else:
            style = 'style="font-style: italic" '
        print '<a %s href="%s?entryid=%d" title="Edit this entry" class="author-%d">%s</a>' % (style, EDITURL, eid, entry['author'], entry['title'])
        print '</td>'
        print '<td align="center"><a href="%s?trackback=1&amp;entryid=%d" title="Manage trackbacks">&laquo; %d &raquo; %d</a>' % (EDITURL, eid, tbcount.get(eid, 0), pings.get(eid, 0))
        print '<td>%s</td>' % cgi.escape(entry.fields.authorname)
        print '<td>%s</td><td>%s</td>' % (datestr, lmstr)
        print '</tr>'
    print '</table>'
    print '</div>'
    blog.footer()

UA = '%s (posting module; %s)' % (blog.LS_BLOG_VERSION, blog.LS_BLOG_URL)

from HTMLParser import HTMLParser
import htmlentitydefs

class TitleHTMLParser(HTMLParser):
    def __init__(self):
        HTMLParser.__init__(self)
        self.title = u''
        self._data = u''

    def handle_starttag(self, tag, attrs):
        if tag == 'title':
            self._data = u''

    def handle_endtag(self, tag):
        if tag == 'title':
            self.title = self._data
            self._data = u''

    def handle_data(self, data):
        self._data += data

    def handle_charref(self, name):
        if name.isdigit():
            self._data += unichr(int(name))
        else:
            self._data += '&#'+name+';'

    def handle_entityref(self, name):
        ref = htmlentitydefs.name2codepoint.get(name)
        if ref:
            self._data += unichr(ref)
        else:
            self._data += '&'+name+';'

def post_from_url(url, req=None, cookies=None):
    import pprint

    if url.startswith('http'):
        urls = trackback.discover_tb(url, referrer=None, returnall=True)
        if not urls:
            try:
                parser = TitleHTMLParser()

                req = urllib2.Request(url, headers={'User-Agent' : UA,})
                page = urlutils.open_url(req)
                parser.feed(page.read())
                page.close()
                parser.close()

                urls = [(url, parser.title.encode('UTF-8'))]
            except:
                urls = [(url, u'')]
    else:
        urls = [(url, u'')]

    #pprint.pprint(urls)

    if len(urls) == 1:
        make_new_post_form(bodylink = urls[0])
        return

    selectlist = []
    for url in urls:
        if url[1]:
            selectlist.append( ('%s %s' % (url), url[1]) )
        else:
            selectlist.append( (url[0], url[0]) )

    try:
        use_style = cookies['style'].value
    except:
        use_style = blog_config.DEF_STYLESHEET
    blog.header(BLOG_TITLE+": Make new post with link", req=req,
                use_style=use_style)

    print '<div class="blog-stuff">'
    print '<form action="%s" method="get" accept-charset="utf-8 ascii">' % LINKPOSTURL
    print '<p>Select the post to link to:'
    print make_select('linkto', selectlist)
    print '<input type="submit" name="submit" value="Submit" />'
    print '</p></form>'

def make_new_post_form(bodylink=None, req=None, cookies=None):
    title = body = ''
    author = 1
    tlist = []
    visible = True
    entry = {'visible' : True, 'pinned' : False, 'author' : author,
             'ping' : True, 'wlping' : True }

    try:
        use_style = cookies['style'].value
    except:
        use_style = blog_config.DEF_STYLESHEET

    blog.header(BLOG_TITLE+': Add entry', use_style=use_style)

    if bodylink:
        url, title = bodylink
        title = cgi.escape(title, 1)
        if TEXTILE:
            # Escape parentheses
            title = title.replace('(', '&amp;#40;')
            title = title.replace(')', '&amp;#41;')
            entry['body'] = '"[link text here](%s)":%s ' % (title, url)
        else:
            url = cgi.escape(url, 1)
            entry['body'] = '<a href="%s" title="%s">[link text here]</a> ' % (
                url, title)

    db = psycopg.connect(DSN)
    edit_form(entry, db, preview=False, textile=TEXTILE, ping=True,
              wlping=True, tlist=tlist)
    blog.footer()

def manage_trackbacks(eid, style):
    db = psycopg.connect(DSN)
    c = db.cursor()
    c.execute('SELECT title FROM content WHERE entryid=%d' % eid)
    titles = [x[0] for x in c.fetchall()]
    if not titles:
        blog.failed_query('Invalid/missing entryid.')
        return
    title = titles[0]

    c.execute('SELECT oid, title, url, excerpt, blog_name, added, ip '
              'FROM trackback WHERE entryid=%d ORDER BY added' % eid)
    R = db_row.MetaRow(c.description)
    pings = [R(row) for row in c.fetchall()]

    c.execute('SELECT tburl FROM pinged WHERE entryid=%d ORDER BY tburl' % eid)
    pinged = [row[0] for row in c.fetchall()]

    db.close()
    blog.header(title=BLOG_TITLE+": Managing trackbacks for "+title,
                use_style=style)

    print '<p><a href="%s">[Post Admin]</a>' % ADMINURL
    print '<a href="%s?entryid=%d">[Edit This Post]</a>' % (EDITURL, eid)
    print '<a href="%s">[BlogFront]</a></p>' % URL

    if pinged:
        print '<p>Trackback pings sent from this entry:</p><ul>'
        print '\n'.join([ ('<li>%s</li>' % x) for x in pinged])
        print '</ul>'
    else:
        print '<p>No trackbacks sent from this entry.</p>'

    if not pings:
        print '<p>No trackbacks received for this entry.</p>'
        blog.footer()
        return

    print '<p>Trackbacks received for this entry:</p>'

    print '<form action="%s" method="POST">' % MODURL
    print '<input type="hidden" name="trackback" value="1" />'
    print '<input type="hidden" name="entryid" value="%d" />' % eid
    print '<table class="admin" width="100%"><tr class="admin-top"><th>Title</th><th width="40%">Excerpt</th><th>Blog Name</th><th>Added</th><th>Received From</th><th>Controls</th></tr>'
    for ping in pings:
        print '<tr>'
        print '<td><a href="%s">%s</a></td>' % (cgi.escape(ping.fields.url, 1),
                                                cgi.escape(ping.fields.title))
        print '<td>%s</td>' % cgi.escape(ping.fields.excerpt)
        print '<td>%s</td>' % cgi.escape(ping.fields.blog_name)
        added = ping.fields.added.strftime('%F %R')
        print '<td align="center">%s</td>' % cgi.escape(added)
        if ping.fields.ip:
            print '<td align="center">%s</td>' % cgi.escape(ping.fields.ip)
        else:
            print '<td align="center">(not recorded)</td>'
        print '<td align="center"><input type="submit" value="Delete" name="delete-%d" /></td>' % ping.fields.oid
        print '</tr>'

    print '</table>'
    print '</form>'

    blog.footer()


def test():
    #post_from_url('http://www.cleverhack.com/blog/')
    #post_from_url('http://www.instapundit.com/')
    #post_from_url('http://blog.davidjanes.com/')
    post_from_url('http://blog.lordsutch.com/')
    pass

if __name__ == '__main__':
    test()
