#!/usr/bin/env python

# You should probably run this as a cron job every 15 minutes or so

from __future__ import generators

import blog_config, db_row, psycopg, urlutils, sql, blog, urllib2, weblogs
import urlparse, re
from optparse import OptionParser
from mx import DateTime

import technorati
import sys

def main():
    usage = 'usage: %prog [options]'
    parser = OptionParser(usage=usage,
                          version='%prog '+blog.LS_BLOG_VERSION)

    parser.add_option('-d', '-v', '--debug', dest='debug', action='store_true',
                      default=False, help='display debugging output')
    (options, args) = parser.parse_args()

    DEBUG = options.debug
    if DEBUG:
        print >> sys.stderr, "Debugging on."

    if not blog_config.TECHNORATI_API_KEY:
        print >> sys.stderr, 'You need a Technorati API key to use this!'
        print >> sys.stderr, 'See http://www.technorati.com//members/apikey.html'
        sys.exit(1)

    db = psycopg.connect(blog_config.DSN)
    db.commit()
    cursor = db.cursor()
    cursor.execute("TRUNCATE cosmos")

    technorati.setLicense(blog_config.TECHNORATI_API_KEY)
    #cosmos = technorati.cosmos(blog_config.URL, search_type="weblog")
    try:
        cosmos = technorati.cosmos(blog_config.URL)
    except (IOError, urlutils.Timeout):
        return

    seen = {}
    for linker in cosmos.item:
        entry = {'name' : blog.strip_html(linker.name.strip())[:128],
                 'url' : linker.url.strip()[:128],
                 'rssurl' : linker.rssurl[:128],
                 'inboundblogs' : linker.inboundblogs,
                 'inboundlinks' : linker.inboundlinks,
                 }
        tag = (entry['name'])
        if DEBUG:
            print tag, seen
        if tag not in seen:
            seen[tag] = True
            cmd = sql.Insert('cosmos', entry)
            cursor.execute(str(cmd))
            if DEBUG:
                print entry

    db.commit()
    return

if __name__ == '__main__':
    main()
