#!/usr/bin/python

# Cheesy script to go through the blogroll and locate any available RSS
# feeds for the blogs in it.

from __future__ import generators

import psycopg
import db_row
import rssfinder
import sql
import blog_config
import urlparse
import sgmllib

if not 'enumerate' in dir(__builtins__):
    def enumerate(collection):
        'Generates an indexed series:  (0,coll[0]), (1,coll[1]) ...'
        i = 0
        it = iter(collection)
        while 1:
            yield (i, it.next())
            i += 1

class FOAFLinkParser(rssfinder.BaseParser):
    FOAFTYPE = ('application/rdf+xml', 'text/xml')
    def do_link(self, attrs):
        rels = [v for k,v in attrs if k=='rel']
        if not rels: return
        if rels[0].lower() <> 'meta': return
        titles = [v for k,v in attrs if k=='title']
        if not titles: return
        if titles[0].lower() <> 'foaf': return
        types = [v for k,v in attrs if k=='type']
        if not types: return
        type = types[0]
        isRSSType = 0
        for t in self.FOAFTYPE:
            isRSSType = type.startswith(t)
            if isRSSType: break
        if not isRSSType: return
        hrefs = [v for k,v in attrs if k=='href']
        if not hrefs: return
        self.links.append(urlparse.urljoin(self.baseuri, hrefs[0]))

_gatekeeper = rssfinder.URLGatekeeper()

def get_foaf_url(url):
    data = _gatekeeper.get(url)
    p = FOAFLinkParser(url)
    p.feed(data)
    #print p.links
    if p.links:
        return p.links[0]

    return None

if __name__ == '__main__':
    db = psycopg.connect(blog_config.DSN)
    db.commit()
    cursor=db.cursor()

    cursor.execute("SELECT name, url, rssurl, foafurl FROM blogroll "
                   "ORDER BY lower(name)")
    R = db_row.MetaRow(cursor.description)
    blogroll = [R(row) for row in cursor.fetchall()]

    for blog in blogroll:
        print 'Querying %s (%s)' % (blog.fields.name, blog.fields.url)

        # XXX: Hack
        if blog.fields.name.lower() < 'bigjim tongue untied':
            continue
        if not blog.fields.foafurl:
            try:
                foafurl = get_foaf_url(blog.fields.url)
            except:
                foafurl = None
            if foafurl:
                query = sql.Update('blogroll',
                                   {'foafurl' : foafurl},
                                   {'name' : blog.fields.name,
                                    'url' : blog.fields.url})
                print str(query)
                db.commit()
                cursor.execute( str(query) )
                db.commit()

        if not blog.fields.rssurl:
            try:
                feeds = rssfinder.getFeeds(blog.fields.url)
            except:
                continue

            if not feeds:
                continue

            if len(feeds) == 1:
                selected_feed = feeds[0]
            else:
                print 'Multiple feeds for %s:' % blog.fields.url
                for (i, feed) in enumerate(feeds):
                    print '%-2d. %s' % (i, feed)
                feednum = raw_input('Choose a feed by number: ')
                i = int(feednum)
                selected_feed = feeds[i]

            query = sql.Update('blogroll',
                               {'rssurl' : selected_feed},
                               {'name' : blog.fields.oid,
                                'url' : blog.fields.url})
            print str(query)
            db.commit()
            cursor.execute( str(query) )
            db.commit()
