#!/usr/bin/python
# -*- python -*-
#
# A thoroughly lame weblog
# (C) 2002-03 Chris Lawrence

import cgitb; cgitb.enable()

import sys, cgi, psycopg, re, os, trackback, urllib, sql, Cookie
import blog_admin, weblogs, tidy, textile

import blog
from blog_config import *
from blog import *

from ezFieldStorage import ezFieldStorage

def process_new_author(form):
    db = psycopg.connect(DSN)
    cursor = db.cursor()

    entry = {}
    for field in ('authorname', 'authoremail', 'authorurl', 'login'):
        x = form.getfirst(field)
        if x is not None:
            entry[field] = x

    query = sql.Insert('authors', entry)
    cursor.execute(str(query))
    db.commit()
    header('Done', extra_headers=[('Status', '302 Update successful'),
                                  ('Location', ADMINURL)])
    print '<a href="%s">Return to blog.</a>' % ADMINURL
    footer()

def process_new_topic(form):
    db = psycopg.connect(DSN)
    cursor = db.cursor()

    entry = {}
    for field in ('topicname', 'topicdesc', 'odtopic'):
        x = form.getfirst(field)
        if x is not None:
            entry[field] = x

    query = sql.Insert('topics', entry)
    cursor.execute(str(query))
    db.commit()
    header('Done', extra_headers=[('Status', '302 Update successful'),
                                  ('Location', ADMINURL)])
    print '<a href="%s">Return to blog.</a>' % ADMINURL
    footer()

_blogroll_fields = ('name', 'comment', 'url', 'rssurl', 'foafurl')
_re_fields = '|'.join(map(re.escape, _blogroll_fields))
_oidre = re.compile(r'(%s|save|delete)-(\d+)$' % _re_fields)
_fieldsre = re.compile(r'(%s)$' % (_re_fields))
def process_blogroll(form):
    db = psycopg.connect(DSN)
    cursor = db.cursor()

    formkeys = form.keys()
    if form.has_key('add'):
        entry = {}
        for field in _blogroll_fields:
            if form.has_key(field):
                entry[field] = form.getfirst(field)
        if entry and 'url' in entry and 'name' in entry:
            query = sql.Insert('blogroll', entry)
            #print >> sys.stderr, query
            cursor.execute(str(query))
    elif form.has_key('save'):
        oids = {}
        for k in formkeys:
            m = _oidre.match(k)
            if not m: continue
            field, oid = m.group(1), int(m.group(2))
            if not oid in oids:
                oids[oid] = {}
            oids[oid][field] = form.getfirst(k)

        for (oid, entry) in oids.iteritems():
            query = sql.Update('blogroll', entry, {'oid' : oid})
            #print >> sys.stderr, query
            cursor.execute(str(query))
        # Also add, if that block is filled in
        entry = {}
        for field in _blogroll_fields:
            if form.has_key(field):
                entry[field] = form.getfirst(field)
        if entry and 'url' in entry and 'name' in entry:
            query = sql.Insert('blogroll', entry)
            #print >> sys.stderr, query
            cursor.execute(str(query))
    else:
        fields = {}
        for k in formkeys:
            m = _oidre.match(k)
            if not m: continue
            action, oid = m.group(1), int(m.group(2))
            if action == 'save':
                entry = {}
                newre = re.compile(r'(%s)-%d$' % (_re_fields, oid))
                for field in _blogroll_fields:
                    entry[field] = ''
                for k in formkeys:
                    m = newre.match(k)
                    if not m: continue
                    field = m.group(1)
                    entry[field] = form.getfirst(k)
                query = sql.Update('blogroll', entry, {'oid' : oid})
                #print >> sys.stderr, query
                cursor.execute(str(query))
                break
            elif action == 'delete':
                query = sql.Delete('blogroll', {'oid' : oid})
                #print >> sys.stderr, query
                cursor.execute(str(query))
                break

    db.commit()
    header('Done', extra_headers=[('Status', '302 Update successful'),
                                  ('Location', ADMINURL+'?blogroll=1')])
    print '<a href="%s?blogroll=1">Return to blog.</a>' % ADMINURL
    footer()

def process_trackback(form):
    entryid = form.get('entryid')
    if entryid:
        try:
            entryid = int(entryid)
        except:
            entryid = None

    db = psycopg.connect(DSN)
    c = db.cursor()

    formkeys = form.keys()
    for k in formkeys:
        m = re.match(r'delete-(\d+)', k)
        if m:
            oid = int(m.group(1))
            c.execute('DELETE FROM trackback WHERE oid=%d' % oid)

    db.commit()
    db.close()

    url = '%s?trackback=1&entryid=%d' % (EDITURL, entryid)
    header('Done', extra_headers=[('Status', '302 Delete successful'),
                                  ('Location', url)])
    print '<a href="%s">Return to blog.</a>' % cgi.escape(url, 1)
    footer()


def main():
    form = ezFieldStorage()
    if form.has_key('newauthor'):
        return process_new_author(form)
    elif form.has_key('newtopic'):
        return process_new_topic(form)
    elif form.has_key('blogroll'):
        return process_blogroll(form)
    elif form.has_key('trackback'):
        return process_trackback(form)

    db = psycopg.connect(DSN)
    cursor = db.cursor()

    entry = {'extended' : ''}

    entryid = form.get('entryid')
    if entryid:
        try:
            entryid = int(entryid)
        except:
            entryid = None

    delete = ('delete' in form)
    ping = ('ping' in form)
    wlping = ('wlping' in form)
    updatemod = ('updatemod' in form)
    manualtb = form.get('manualtb')
    try:
        tlist = [int(x) for x in form.getlist('topic')]
    except:
        tlist = []

    if updatemod:
        entry['lastmod'] = 'now()'

    FIELDS = {'title' : 's', 'body' : 's', 'extended' : 's',
              'upload' : 's', 'visible' : 's', 'excerpt' : 's',
              'author' : 'd', 'lastmod' : 's', 'pinned' : 's'}

    for (field, ftype) in FIELDS.iteritems():
        x = form.get(field)
        if field in ('visible', 'pinned'):
            if x:
                entry[field] = 'True'
            else:
                entry[field] = 'False'
        elif x:
            x = x.decode('UTF-8', 'replace')
            if field in ('title', 'excerpt'):
                x = strip_html(x).decode('UTF-8')
            elif field in ('body', 'upload', 'extended'):
                if field == 'upload':
                    field = 'body'
                if form.getfirst('textile'):
                    x = textile.textile(x)
                x, errors = tidy.tidy(x)
                if errors:
                    print >> sys.stderr, 'Tidy errors:', repr(errors)
            x = x.strip()

            if ftype == 'd':
                try:
                    entry[field] = int(x)
                except:
                    pass
            else:
                entry[field] = x.encode('UTF-8')

    cookie_str = os.environ.get('HTTP_COOKIE', '')
    try:
        cookies = Cookie.BaseCookie(cookie_str)
    except Cookie.CookieError:
        cookies = Cookie.BaseCookie()

    try:
        use_style = cookies['style'].value
    except:
        use_style = blog_config.DEF_STYLESHEET

    preview = 'preview' in form
    if preview:
        if entryid:
            title = BLOG_TITLE+': Preview modified entry'
        else:
            title = BLOG_TITLE+': Preview new entry'
        header(title, use_style=use_style)
        blog_admin.edit_form(entry, db, entryid, updatemod=updatemod,
                             preview=True, wlping=wlping, ping=ping,
                             manualtb=manualtb, tlist=tlist)
        print '<!-- '
        for url in trackback.grab_embedded_urls(entry['body']):
            print url
        print '-->'
        #print '<!-- %s %s -->' % (repr(entry), form.get('pinned'))
        footer()
        return

    if not entry or 'title' not in entry:
        blog.failed_query('Invalid entry content.')
        return

    if delete and entryid:
        # Delete all entries from the topicmap for this entry first, to
        # avoid a referential integrity check problem...
        query = sql.Delete('topicmap', {'entryid' : entryid})
        cursor.execute(str(query))
        query = sql.Delete('trackback', {'entryid' : entryid})
        cursor.execute(str(query))
        query = sql.Delete('best', {'entryid' : entryid})
        cursor.execute(str(query))
        query = sql.Delete('pinged', {'entryid' : entryid})
        cursor.execute(str(query))
        # And commit the deletions(!)
        db.commit()
        # Now delete the actual entry...
        query = sql.Delete('content', {'entryid' : entryid})
    elif entryid:
        query = sql.Update('content', entry, {'entryid' : entryid})
    else:
        query = sql.Insert('content', entry)
    cursor.execute(str(query))
    db.commit()

    if delete:
        header('Done', extra_headers=[('Status', '302 Update successful'),
                                      ('Location', ADMINURL)])
        print '<a href="%s">Return to blog.</a>' % ADMINURL
        footer()
        return

    if not entryid:
        oid = cursor.lastoid()
        cursor.execute("SELECT entryid, to_char(date AT TIME ZONE 'UTC', "
                       "'YYYYMMDD') AS today FROM content WHERE oid=%d" % oid)
        entryid, today = cursor.fetchone()
    else:
        cursor.execute("SELECT to_char(date AT TIME ZONE 'UTC', 'YYYYMMDD') "
                       "AS today FROM content WHERE entryid=%d" % entryid)
        today = cursor.fetchone()[0]

    body = entry['body']
    excerpt = entry.get('excerpt')
    if not excerpt:
        excerpt = make_excerpt(body)
    excerpt = escape_nonascii(excerpt)

    extended = entry.get('extended')
    if not extended:
        extended = ''

    title = escape_nonascii(form.get('title', ''))

    # Update the per-entry topic mapping
    query = sql.Delete('topicmap', {'entryid' : entryid})
    cursor.execute(str(query))
    for topic in tlist:
        query = sql.Insert('topicmap', {'topic' : topic, 'entryid' : entryid})
        cursor.execute(str(query))

    query = sql.Delete('best', {'entryid' : entryid})
    cursor.execute(str(query))
    if form.get('best'):
        query = sql.Insert('best', {'entryid' : entryid})
        cursor.execute(str(query))
    db.commit()

    url = blog.make_permalink(entryid, today)
    # XXX: Add exception handling here...
    if manualtb:
        manualtb = manualtb.strip()
        trackback.send_ping(manualtb, excerpt=excerpt,
                            title=title, url=url, blog_name=BLOG_TITLE)

        # Record manual trackbacks too
        query = sql.Insert('pinged', {'tburl' : manualtb, 'entryid' : entryid})
        cursor.execute(str(query))
        db.commit()

    if ping:
        cursor.execute('SELECT tburl FROM pinged WHERE entryid=%d' % entryid)
        pings = [x[0] for x in cursor.fetchall()]

        newpings = trackback.ping_embedded_urls(
            body+extended, pinged=pings, title=title, url=url,
            excerpt=excerpt, blog_name=BLOG_TITLE)

        db.commit()
        query = sql.Delete('pinged', {'entryid' : entryid})
        cursor.execute(str(query))
        for p in newpings:
            query = sql.Insert('pinged', {'tburl' : p, 'entryid' : entryid})
            cursor.execute(str(query))
        db.commit()

    if wlping:
        ok = weblogs.ping_all(BLOG_TITLE, URL)

    header('Done', extra_headers=[('Status', '302 Update successful'),
                                  ('Location', ADMINURL)])
    print '<a href="%s">Return to blog.</a>' % ADMINURL
    footer()
    db.close()

if __name__ == '__main__':
    main()
