#!/usr/bin/python2.2
# -*- python -*-
#
# A thoroughly lame weblog: Publisher interface
# (C) 2002-03 Chris Lawrence

# Theory of operation:
# - Use postgresql to do the heavy lifting; that's why we have databases
#
# Tables:
# - content
# - topics
# - authors

import sys, psycopg, re, urllib, os, cStringIO, blog, blog_config
import cgi, Cookie

from mod_python import apache
from mx import DateTime

def _make_cookie(key, val):
    cookies = Cookie.BaseCookie()
    cookies[key] = val
    cookies[key]['Path'] = '/'
    cookies[key]['Comment'] = 'Stylesheet for this page'
    cookies[key]['Version'] = '1'
    cookies[key]['Max-Age'] = '86400000'
    return cookies.output(header='').strip()

def setcookie(req, style=None, tz=None, limit=None, blogroll=None,
              fullroll=None):
    referrer = blog_config.URL
    if referrer.find('force_refresh=1') >= 0:
        pass
    elif '?' in referrer:
        referrer += '&force_refresh=1'
    else:
        referrer += '?force_refresh=1'
    req.err_headers_out.add('Location', referrer)
    req.err_headers_out.add('Cache-Control', 'private')
    req.err_headers_out.add('Cache-Control', 'no-cache="set-cookie"')
    req.err_headers_out.add('Expires', 'Fri, 01 Jan 1971 00:00:00 UTC')

    if style:
        req.err_headers_out.add('Set-Cookie', _make_cookie('style', style))

    if tz:
        req.err_headers_out.add('Set-Cookie', _make_cookie('timezone', tz))

    if limit:
        req.err_headers_out.add('Set-Cookie', _make_cookie('limit', limit))

    if blogroll:
        req.err_headers_out.add('Set-Cookie', _make_cookie('blogroll', blogroll))

    fullroll = str(int(fullroll is not None))
    req.err_headers_out.add('Set-Cookie', _make_cookie('fullroll', fullroll))

    raise apache.SERVER_RETURN, apache.HTTP_MOVED_PERMANENTLY

def newindex(req, **args):
    blog.start_timing()
    referrer = req.headers_in.get('Referer')
    localref = referrer and referrer.startswith(blog_config.URL)

    cookie_str = req.headers_in.get('Cookie', '')
    try:
        cookies = Cookie.BaseCookie(cookie_str)
    except CookieError:
        cookies = Cookie.BaseCookie()

    ims = req.headers_in.get('If-Modified-Since')

    out, newout = sys.stdout, cStringIO.StringIO()
    sys.stdout = newout
    resp = blog.generate_page(req, localref=localref, cookies=cookies, ims=ims, **args)
    if resp and resp != 200:
        raise apache.SERVER_RETURN, resp

    sys.stdout = out
    return newout.getvalue()

def config(req):
    cookie_str = req.headers_in.get('Cookie', '')
    try:
        cookies = Cookie.BaseCookie(cookie_str)
    except CookieError:
        cookies = Cookie.BaseCookie()

    out, newout = sys.stdout, cStringIO.StringIO()
    sys.stdout = newout
    resp = blog.configpage(cookies, req=req)
    if resp and resp != 200:
        raise apache.SERVER_RETURN, resp

    sys.stdout = out
    return newout.getvalue()

index = newindex
