import sys, cgi, re, urllib, htmlentitydefs, psycopg, os, blog_config, time
import glob
import db_row
import urlparse
from blog_config import *
from mx import DateTime

import sgmllib

LS_BLOG_VERSION_NUMBER='0.8.1'

DOCTYPE = '''<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">'''
#DOCTYPE = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">'

class Stripper(sgmllib.SGMLParser):
    def __init__(self):
        sgmllib.SGMLParser.__init__(self)
        
    def strip(self, some_html):
        self.theString = u""
        self.feed(some_html)
        self.close()
        return self.theString
       	
    def handle_data(self, data):
        self.theString += data.decode('UTF-8')

    def handle_entityref(self, ref):
        x = htmlentitydefs.name2codepoint.get(ref)
        if x:
            self.theString += unichr(x)
            
    def handle_charref(self, ref):
        try:
            i = int(ref)
            self.theString += unichr(i)
        except ValueError:
            pass

QURL = urllib.quote(URL)

LS_BLOG='LSblog'
LS_BLOG_VERSION='%s/%s' % (LS_BLOG, LS_BLOG_VERSION_NUMBER)
LS_BLOG_URL='http://blog.lordsutch.com/?topic=20'

FULLRSSURL = urlparse.urljoin(URL, RSSURL)
FULLOPMLURL = urlparse.urljoin(URL, OPMLURL)

striphtmlre = _striphtmlre = re.compile(r'</?.*?>', re.DOTALL)
_nonare = re.compile(r'<[^a/].*?>|<a(!=\s)+.*?>|</[^a]\w*>|</a\s*(?!>).*?>', re.I | re.DOTALL)

_entityre = re.compile(r'&([A-Za-z][A-Za-z0-9]+);', re.UNICODE)
def recode_content(body, encoding='utf-8', escape=False, recodeonly=False):
    "Converts any entities in the argument to numeric references."
    def fixup_entity(match):
        "Substitution function - converts entities into numeric equivalents."
        val = htmlentitydefs.name2codepoint.get(match.group(1))
        if val is not None:
            return '&#%d;' % val
        return match.group()

    def fixup2(match):
        val = htmlentitydefs.name2codepoint.get(match.group(1))
        if val is not None:
            return unichr(val)
        return match.group()

    if isinstance(body, str):
        body = body.decode(encoding)

    if recodeonly:
        x = _entityre.sub(fixup2, body)
        return x.encode(encoding)
    elif escape:
        x = _entityre.sub(fixup2, body)
        return cgi.escape(x.encode(encoding), 1)
    else:
        return _entityre.sub(fixup_entity, body).encode(encoding)

def make_button(link, button, text, width=80, height=15):
    button = urlparse.urljoin(BUTTONS, button)
    return '<a href="%(link)s"><img src="%(button)s" width="%(width)d" height="%(height)d"  alt="%(text)s" title="%(text)s" /></a>' % locals()

def make_li_button(link, button, text, width=80, height=15):
    return '<li>'+make_button(link, button, text, width, height)+'</li>'

def make_excerpt(body, keeplinks=False, truncate=True):
    # Turn entities into numeric references
    if isinstance(body, unicode):
        body = body.encode('UTF-8')
    body = recode_content(body)
    if keeplinks:
        stripped = _nonare.sub('', body)
        return stripped

    #stripped = _striphtmlre.sub('', body)
    stripped = Stripper().strip(body).encode('UTF-8')
    bits = stripped.split(None, EXCERPT_WORDS+1)
    if truncate and len(bits) > EXCERPT_WORDS:
        return ' '.join(bits[:EXCERPT_WORDS])+'...'
    return ' '.join(bits)

def strip_html(body):
    content = make_excerpt(body, truncate=False)
    content = recode_content(content, recodeonly=True)
    return content

def escape_nonascii(body, encoding='UTF-8'):
    if isinstance(body, str):
        body = body.decode(encoding)
    body = cgi.escape(body, 1)
    body = body.encode('ascii', 'xmlcharrefreplace')
    return body

def escape(body, encoding='UTF-8'):
    body = strip_html(body)
    return escape_nonascii(body)

_t = None
def start_timing():
    global _t

    _t = os.times()[0:2]

def end_timing():
    return (os.times()[0] - _t[0], os.times()[1] - _t[1])

BLOG_LONGDESC_STRIPPED = make_excerpt(BLOG_LONGDESC, truncate=False)

METADATA = {
    'tgn.id' : LOCATION['tgn.id'],
    'tgn.name' : LOCATION['city'],
    'tgn.nation' : LOCATION['full_country'],
    'geo.placename' : '%(city)s, %(state)s' % LOCATION,
    'geo.position': '%(latitude).3f;%(longitude).3f;%(altitude).3f' % LOCATION,
    'geo.city' : LOCATION['city'],
    'geo.state' : LOCATION['state'],
    'geo.country' : LOCATION['country'],
    'geo.postal' : LOCATION['zip'],
    'geo.accuracy' : '3',
    'ICBM' : '%(latitude).3f,%(longitude).3f' % LOCATION,
    'geo.latitude' : '%(latitude).3f' % LOCATION,
    'geo.longitude' : '%(longitude).3f' % LOCATION,
    'DC.Title' : BLOG_TITLE,
    'DC.Type' : 'Collection',
    'DC.Creator' : OWNER,
    'author' : OWNER,
    'DC.Identifier' : URL,
    'DC.Language' : LANG,
    'WMDI.Trackback' : 'Y',
    'WMDI.Comments' : 'N',
    'DC.Description' : BLOG_LONGDESC_STRIPPED,
    'WMDI.ContactInfo' : CONTACT_URI,
    'WMDI.CMS' : LS_BLOG,
    'DC.Format' : 'html',
    'DC.Subject' : KEYWORDS,
    'Keywords' : KEYWORDS,
    }

def make_checked(tf):
    'Mark a radio button or checkbox.'
    if isinstance(tf, (int, long)):
        if tf:
            return 'checked="checked"'
        return ''
    elif not tf:
        return ''
    elif tf.lower() in ('true', 'on'):
        return 'checked="checked"'
    return ''

def create_checkbox(name, label=None, accesskey=None, checked=False):
    if label:
        return '<label accesskey="%s"><input type="checkbox" name="%s" %s /> %s</label><br />' % (accesskey or "", name, make_checked(checked), label)
    return '<input type="checkbox" name="%s" %s />' % (name, make_checked(checked))

def make_select(id, itemdict, selected=None, multiple=False, size=6):
    "Make a <select> form element from a mapping or sequence."
    if multiple:
        ismult = 'multiple="multiple" size="%d"' % size
    else:
        ismult = 'size="1"'
    
    s = '<select name="%s" %s>\n' % (id, ismult)
    if isinstance(itemdict, dict):
        items = itemdict.iteritems()
    else:
        items = itemdict

    if not selected:
        selected = []
    elif isinstance(selected, (str, unicode, int, float)):
        selected = [selected]
        
    for (val, label) in items:
        sel = ''
        if val in selected:
            sel = ' selected="selected"'
        s += '<option value="%s"%s>%s</option>\n' % (val, sel, label)
    s += '</select>'
    
    return s

_zonefiles = [('/usr/lib/zoneinfo/zone.tab', '/usr/lib/zoneinfo/iso3166.tab'),
              ('/usr/share/zoneinfo/zone.tab', '/usr/share/zoneinfo/iso3166.tab')
              ]
_zonere = re.compile(r'([A-Z]{2})\s+([+-]\d+[+-]\d+)\s+([A-Za-z/_-]+)(.*)$')
_countryre = re.compile(r'([A-Z]{2})\s+(.*)$')
def read_timezone_list(zonefile, countryfile):
    tzs = {
        'GMT' : 'Greenwich Mean Time (GMT)',
        'UTC' : 'Coordinated Universal Time (UTC)',
        #'Zulu' : 'Zulu (Military Time - UTC)'
        }
    countries = {}
    if os.path.exists(countryfile):
        for line in file(countryfile):
            m = _countryre.match(line)
            if m:
                code, name = m.groups()
                name = name.strip()
                countries[code] = name
            
    for line in file(zonefile):
        m = _zonere.match(line)
        if m:
            country, coords, tzname, tzdesc = m.groups()
            tzdesc = tzdesc.strip()
            country = countries.get(country, country)
            if tzdesc:
                tzdesc = '%s &mdash; %s' % (country, tzdesc)
            else:
                tzdesc = country
            if tzname in tzs:
                tzs[tzname] = '%s, %s' % (tzs[tzname], tzdesc)
            else:
                tzs[tzname] = tzdesc
    tzs = [(x, '%s: %s' % (x, y)) for (x, y) in tzs.iteritems()]
    tzs.sort()
    return tzs

_tzfilter = re.compile(r'[^_a-z/0-9+-]', re.I)
def get_timezone_list():
    for (zonefile, countryfile) in _zonefiles:
        if os.path.exists(zonefile):
            return read_timezone_list(zonefile, countryfile)
    return []

def configpage(cookies, req=None):
    try:
        use_style = cookies['style'].value
        defsel = False
    except:
        use_style = blog_config.DEF_STYLESHEET
        defsel = True

    header(BLOG_TITLE+': Set your preferences', req=req, use_style=use_style)
    print '<h1>%s: Set your preferences</h1>' % BLOG_TITLE
    print '<p>These settings will be stored as a cookie in your browser.'
    print 'You will need to set these preferences on each computer you view'
    print 'this weblog from.</p>'

    print '<form action="%s" method="POST">' % COOKIEURL
    print '<div class="choosestyle"><div class="sidebar-header">Choose a stylesheet for this weblog:</div><ul class="nav-indent">'
    styles = STYLESHEETS.items()
    styles.sort(lambda x, y: cmp(x[1], y[1]) or cmp(x, y))

    selected = ''
    if defsel:
        selected = 'checked="checked"'
    print '<li><label><input type="radio" name="style" value="default" %s />Always use default</label></li>' % selected
    for (k, v) in styles:
        selected = ''
        extra = ''
        if not defsel and (k == use_style):
            selected = 'checked="checked"'
        if k == blog_config.DEF_STYLESHEET:
            extra = '<strong>(current default)</strong>'
        print '<li><label><input type="radio" name="style" value="%s" %s />%s %s</label></li>' % (k, selected, v[0], extra)
    print '</ul></div>'

    try:
        blogroll = cookies['blogroll'].value
    except:
        blogroll = 'date'

    try:
        fullroll = bool(int(cookies['fullroll'].value))
    except:
        fullroll = False

    bropts = (('date', 'most recently updated at top'),
              ('alpha', 'alphabetical order'),
              )

    print '<div>%s</div>' % create_checkbox(
        'fullroll', '<span class="sidebar-header">Show full blogroll by default.</span>', checked=fullroll)
    print '<div><label><span class="sidebar-header">Sort blogroll:</span> %s</label></div>' % make_select('blogroll', bropts, blogroll)

    try:
        tz = _tzfilter.sub('', cookies['timezone'].value)
    except:
        tz = blog_config.TIMEZONE

    print '<!-- Time zone setting here -->'
    tzs = get_timezone_list()
    print '<div>'
    print '<label><span class="sidebar-header">Choose time zone:</span> %s</label>' % make_select('tz', tzs, tz)
    print '</div>'
    print '<input type="submit" name="submit" value="Set display preferences" />'
    print '</form>'
    footer()

def header(title='', extra_headers=[], head='', req=None, front=False,
           use_style=DEF_STYLESHEET, latest=None):
    if not title:
        title = '%s: %s' % (BLOG_TITLE, BLOG_DESC)

    headers = [('Content-Language', LANG),
               ('Vary', 'Cookie'),] + extra_headers
    
    if req:
        req.content_type = 'text/html; charset=utf-8'
        for (header, content) in headers:
            req.headers_out.add(header, content)
    else:
        print 'Content-Type: text/html; charset=utf-8'
        for (header, content) in headers:
            print '%s: %s' % (header, content)
        print

    print DOCTYPE
    print '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="%s" lang="%s">\n<head>\n<title>%s</title>\n<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />' % (LANG, LANG, title)
    if TTURL and front:
        print '<script type="text/javascript" src="%s" defer="defer"></script>\n<script type="text/javascript" src="%s" defer="defer"></script>' % (TTURL, TRACKURL)
    print '<script type="text/javascript" src="/showhide.js"></script>'
    print '<meta name="QSM.document" content="\nDC.Type: weblog\nDC.Publisher.Application: %s\n" />' % LS_BLOG
    if latest:
        print '<meta name="DC.Date.Updated" content="%s" />' % iso_str(latest)
    for meta in METADATA.iteritems():
        print '<meta name="%s" content="%s" />' % meta

    print '<link rev="made" href="mailto:%s" />' % MAILTO
    print '<link rel="top" href="%s" />' % URL
    print '<link rel="copyright" href="%s#copyright" />' % URL
    print '<link rel="alternate" href="%s" type="application/rss+xml" title="RSS 2.0 feed (mixed HTML/plain text)" />' % FULLRSSURL
    print '<link rel="alternate" href="%s?version=1" type="application/rss+xml" title="RSS 1.0 feed (mixed HTML/plain text)" />' % FULLRSSURL
    print '<link rel="alternate" href="%s?full=1" type="application/rss+xml" title="RSS 2.0 feed (HTML only)" />' % FULLRSSURL
    print '<link rel="alternate" href="%s?atom=1" type="application/atom+xml" title="Atom feed" />' % FULLRSSURL

    print '<link rel="meta" type="application/rdf+xml" title="FOAF" href="%s?foafmode=1" />' % FULLOPMLURL

    sheet = STYLESHEETS.get(use_style)
    if not sheet:
        sheet = STYLESHEETS[DEF_STYLESHEET]

    print '<link rel="stylesheet" type="text/css" href="%s" />' % sheet[1]
    #for (k, v) in STYLESHEETS.iteritems():
    #    if sheet is v: continue
    #    print '<link type="text/css" rel="alternate stylesheet" title="%s" href="%s" />' % v

    print '<link rel="stylesheet" type="text/css" href="%s" media="print" />' % PRINT_STYLESHEET
    print '<link rel="stylesheet" type="text/css" href="%s" media="handheld" />' % HANDHELD_STYLESHEET
    if head:
        print head
    if TTURL and front:
        print '</head><body class="blog" onload="countTT()">'
    else:
        print '</head><body class="blog">'

def footer():
    print '</body></html>'

def failed_query(message = 'Query failure.', req=None):
    header(title = BLOG_TITLE+': '+message, req=req)
    print '<h1 class="blog">Problem with your request</h1>'
    print '<p class="blog-error">'+message+'</p>'
    footer()

def iso_str(date, local=False):
    date = DateTime.ISO.str(date).replace(' ', 'T')
    return date[:-2]+':'+date[-2:]

def generate_blogtop(plain=False):
    # Any sort of top matter should go here
    print '<div class="topmatter">'
    if plain:
        print PLAIN_TOPMATTER
    else:
        print TOPMATTER
    print '</div>'

def make_url(url, query=None):
    if query:
        return '%s?%s' % (url, '&amp;'.join(query))
    else:
        return url

make_frontlink = lambda entry: '%s#entry-%d' % (URL, entry)
make_daily_permalink=lambda entry, day: '%s?day=%s#entry-%d'% (URL, day, entry)
make_entry_permalink = lambda entry, day=None: '%s?entryid=%d'% (URL, entry)
if DAILY_PERMALINKS:
    make_permalink = make_daily_permalink
    make_other_permalink = make_entry_permalink
else:
    make_permalink = make_entry_permalink
    make_other_permalink = make_daily_permalink

make_tblink = lambda entry: urlparse.urljoin(TBURL+'/', str(entry))

def generate_sidebar(entries, topics=None, frontlink=True, offset=0, limit=20,
                     count=62, welcome=True, author=None, topic=None,
                     recent=None, month=None, months=None, blogroll=None,
                     start=None, use_style=DEF_STYLESHEET, tz=None,
                     overview=False, best=None, dates=None, cosmos=None,
                     topicmap=None, shortroll=True, cookies=None, now=None,
                     authors=None):
    query = []
    if author:
        query.append('author=%d' % author)

    print '<div class="sidebar">'

    if topic:
        for tid, tname, tdesc in topics:
            if tid == topic: break

        if tdesc[-1] not in ';:.,?!':
            tdesc += '.'
        print '<div class="curtopic"><strong>Current Topic: %s.</strong><p>%s</p><p>To view other posts at <cite>%s</cite>, please visit the <a accesskey="B" rel="start" title="Back to the front page." href="%s" class="frontlink">BlogFront</a>.</p></div>' % (tname, tdesc, BLOG_TITLE, URL)
    elif author:
        aname = authors.get(author, 'Unknown')
        print '<div class="curtopic"><strong>You are viewing posts by <span class="author-%d">%s</span>.</strong><p>To view other posts at <cite>%s</cite>, please visit the <a accesskey="B" rel="start" title="Back to the front page." href="%s" class="frontlink">BlogFront</a>.</p></div>' % (author, aname, BLOG_TITLE, URL)
    elif (frontlink or offset):
        # Should have an "author" setting like the "if topic..." aboveC
        print '<div class="curtopic">'
        if frontlink:
            print '<p style="font-weight: bolder">Like what you&rsquo;re reading?</p>'
        print '<p>To view other posts at <cite>%s</cite>, please visit the <a accesskey="B" rel="start" href="%s" title="Back to the front page." class="frontlink">BlogFront</a>.</p></div>' % (BLOG_TITLE, URL)

    if welcome or not frontlink:
        print '<div class="welcome">'
        print WELCOMEBLOCK
        if welcome:
            print LONGWELCOMEBLOCK
        print '</div>'
    
    # Begin navigation box
    print '<div class="blog-nav"><ul class="nav">'

    print '<li class="important"><a href="%s">Set appearance and time zone.</a></li>' % CONFIGURL

    # Daily post navigation
    if dates:
        if dates[0]:
            dcode = dates[0].strftime('%Y%m%d')
            dstr = dates[0].strftime(DATEFMT_STRFTIME).strip()
            print '<li><a href="%s" class="blog-nav-backward">&laquo; %s</a></li>' % (make_url(URL, query+['day=%s' % dcode]), dstr)
        if dates[1]:
            dcode = dates[1].strftime('%Y%m%d')
            dstr = dates[1].strftime(DATEFMT_STRFTIME).strip()
            print '<li><a href="%s" class="blog-nav-forward">%s &raquo;</a></li>' % (make_url(URL, query+['day=%s' % dcode]), dstr)

    if topic:
        query.append('topic=%d' % topic)
    if month:
        query.append('month=%d' % month)
    if overview:
        query.append('overview=1')
    if limit:
        query.append('limit=%d' % limit)

    # Page navigation (perhaps this should be dropped/optional?)
    if limit:
        if not start and offset > 0:
            newoffset = max(offset-limit, 0)
            if newoffset or query:
                print '<li><a accesskey="N" href="%s" class="blog-nav-backward" rev="next" rel="prev">&laquo; Newer Entries</a></li>' % (make_url(URL, query+['offset=%d' % newoffset]))
        if not start and ((offset+limit) < count):
            print '<li><a accesskey="O" href="%s" class="blog-nav-forward" rev="prev" rel="next">Older Entries &raquo;</a></li>' % (make_url(URL, query+['offset=%d' % (offset+limit)]))

    print '<li>'
    print '''\
<form name="feedsterform" action="http://www.feedster.com/search.php">
<input type="text" size="15" name="q">
<!-- <input type="hidden" name="searchtype" value="exsearch"> -->
<input type="hidden" name="inrss" value="%s">
<input type="hidden" name=sort value="date">
<input type="submit" value="Search">
</form>''' % FULLRSSURL
    print '</li>'
    print '</ul></div>'

    if len(entries) > 1:
        print '<div class="shortcuts"><div class="sidebar-header">Entries on this page'
        if SHOWUPDATED:
            print ' (<strong>*</strong>&nbsp;=&nbsp;updated)'
        print '</div><ul class="nav-indent" id="entries">'
        for entry in entries:
            entrytitle = entry.fields.title
            if SHOWUPDATED and entry.fields.fdate != entry.fields.flastmod:
                entrytitle += '<strong>*</strong>'
            print '<li><a href="#entry-%d" class="author-%d">%s</a></li>' % (
                entry.fields.entryid, entry.fields.author, entrytitle)
        print '</ul></div>'

    if recent:
        dmode = 'style="display: none"'
        if len(entries) < 3:
            dmode = ''
        print '<div class="recently"><div class="sidebar-header">Recently&hellip; <a href="javascript:showhide(\'recently\')">&darr;</a></div><ul class="nav-indent" id="recently" %s>' % dmode
        for entry in recent:
            entrytitle = entry.fields.title
            if SHOWUPDATED and entry.fields.fdate != entry.fields.flastmod:
                entrytitle += '<strong>*</strong>'
            print '<li><a href="%s" title="Last modified: %s" class="author-%d">%s</a></li>' % (make_permalink(entry.fields.entryid, entry.fields.today), cgi.escape(entry.fields.flastmod, 1), entry.fields.author, entrytitle)
        print '</ul></div>'
    
    if not frontlink:
        if best:
            print '<div class="best"><div class="sidebar-header">Best of %s</div><ul class="nav-indent" id="best">' % BLOG_TITLE
            for entry in best:
                print '<li><a href="%s" title="Originally posted: %s" class="author-%d">%s</a></li>' % (make_permalink(entry.fields.entryid, entry.fields.today), cgi.escape(entry.fields.fdate, 1), entry.fields.author, entry.fields.title)
            print '</ul></div>'

        if months:
            print '<div class="archives"><div class="sidebar-header">Archives <a href="javascript:showhide(\'archives\')">&darr;</a></div><ul class="nav-indent" id="archives">'
            first = True
            for monthstr, mcount, mid in months:
                print '<li><a title="%d entries" href="%s?month=%s">%s</a></li>' % (mcount, URL, mid, cgi.escape(monthstr))
            print '</ul></div>'

        print '<div class="topicbox">'
        if topics:
            print '<div class="sidebar-header">Topics <a href="javascript:showhide(\'topics\')">&darr;</a></div><ul class="nav-indent" id="topics">'
            for tid, tname, tdesc in topics:
                print '<li><a title="%s" href="%s?topic=%d">%s</a></li>' % (
                    cgi.escape(tdesc,1), URL, tid, cgi.escape(tname))
            print '</ul>'

        #print '<a accesskey="T" rel="Index" title="The most recent post on each topic." href="%s?overview=1" class="blog-overview">Overview of Topics</a>' % URL
        print '</div>'

        if blogroll:
            if shortroll:
                headword = "Active Blogroll"
            else:
                headword = "Full Blogroll"
                
            print '<div class="blogroll"><ul class="nav"><li class="sidebar-header">%s (%d)</li><ul class="nav-indent" id="blogroll">' % (headword, len(blogroll))
            for blog in blogroll:
                if not blog.fields.updated:
                    title = blog.fields.comment or ''
                elif blog.fields.comment:
                    title = '%(comment)s &mdash; Updated: %(updated)s' % blog
                else:
                    title = 'Updated: %(updated)s' % blog
                
                if blog.fields.new:
                    print '<li class="blogroll-new"><a title="%s" href="%s">%s</a></li>' % (title, blog.fields.url, blog.fields.name)
                else:
                    print '<li><a title="%s" href="%s">%s</a></li>' % (title, blog.fields.url, blog.fields.name)

                #if blog.fields.rssurl:
                #    print '<a title="RSS feed" href="%s"><img src="%s" width="36" height="14" alt="[RSS]" /></a>' % (blog.fields.rssurl, XMLLINKURL)
                #print '</li>'

            print '</ul>'

            if shortroll:
                print '<li><a class="blogroll-full" href="%s?fullroll=1">Show full blogroll</a></li>' % URL
            else:
                print '<li><a class="blogroll-full" href="%s?fullroll=0">Show active blogroll</a></li>' % URL

            # Export OPML feed here...
            print '<li><a href="%s" type="text/xml" title="OPML subscription list for this blogroll."><abbr title="Outline Processor Markup Language" class="caps">OPML</abbr> Feed</a></li>' % OPMLURL
            print '''\
<li><form name="feedsterform" action="http://www.feedster.com/search.php">
<input type="text" size="15" name="q">
<input type="submit" value="Search blogroll">
<!-- <input type="hidden" name="searchtype" value="exsearch"> -->
<input type="hidden" name="inopml" value="%s">
<!-- <input type="hidden" name="inrss" value="%s"> -->
<input type="hidden" name=sort value="date">
</form></li>''' % (urlparse.urljoin(URL, OPMLURL), FULLRSSURL)
            print '</ul></div>' #'<a href="http://newhome.weblogs.com/pingSiteForm" >Ping Weblogs.com</a></div>'

        if cosmos:
            print '<div class="cosmos"><ul class="nav"><li class="sidebar-header"><span class="technorati">Technorati</span> Cosmos</li><ul class="nav-indent">'
            for linker in cosmos:
                print '<li><a href="%s">%s</a></li>' % (
                    cgi.escape(linker['url'], 1), linker['name'])
            print '</ul></ul></div>'

    print '<div class="sidebar-footer"><p><ul class="nav">'
    print '<li class="copyright"><p id="copyright">Copyright &copy; %(CYEAR)s %(FULL_OWNER)s.</p>%(CNOTICE)s</li><li>%(CREDITBLOCK)s</li>' % globals()
    print '<li>Powered by:<ul class="nav-inline">'
    print make_li_button(LS_BLOG_URL, 'lsblog.png', LS_BLOG_VERSION)
    print make_li_button(**WEBSERVER), make_li_button(**HOST_OS)
    print make_li_button('http://www.python.org/', 'python.png', 'Python')
    print make_li_button('http://www.postgresql.org/', 'postgres.png',
                         'PostgreSQL')
    if TTURL:
        print make_li_button('http://www.blogmatrix.com/','blogmatrix.png',
                             "BlogMatrix")

    if TECHNORATI_PROFILE:
        print make_li_button(TECHNORATI_PROFILE, 'technorati.png', 'Technorati Profile.')

    print '</ul></li><li>Searches powered by:<ul class="nav-inline">'
    print make_li_button('http://www.feedster.com/', 'feedster.png',
                         'Feedster RSS Search Engine')
    print '</ul></li><li>Conforms with:<ul class="nav-inline">'
    print make_li_button('http://www.w3.org/TR/xhtml1/', 'xhtml10.png',
                         'XHTML&trade; 1.0')
    print make_li_button('http://www.w3.org/TR/REC-CSS2/', 'css.png',
                         'CSS Level 2')
    print '</ul></li>'
    print '</ul></p></div>'

    if not frontlink:
        #print '<div class="syndicate">'
        # Button block
        print '<ul class="nav-inline">'
        print make_li_button(RSSURL, 'rss2.png', 'RSS 2.0 feed')
        print make_li_button(RSSURL+'?version=1', 'rss1.png',
                             'RSS/RDF 1.0 feed')
        print make_li_button(RSSURL+'?atom=1', 'atom.png', 'Atom feed')
        print make_li_button(OPMLURL+'?foafmode=1', 'foaf.png', 'FOAF')
        print make_li_button('http://www.bloglines.com/sub/'+FULLRSSURL,
                             'sub_modern5.png',
                             'Subscribe to this feed with Bloglines.')

        if SYNDIC8URL:
            print make_li_button(SYNDIC8URL, 'syndic8.png', 'Syndic8')

        if GEOURL:
            print make_li_button(GEOURL, 'geourl.png', 'Nearby websites via GeoURL')

        print make_li_button('http://www.technorati.com/cosmos/links.html?url='+QURL, 'technorati.png', 'Inbound links to this weblog via Technorati.')
        print make_li_button("http://www.truthlaidbear.com/showdetails.php?host="+QURL[:-1], 'ttlb.png', 'Inbound links to this weblog via The Truth Laid Bear.')
        print make_li_button('http://www.daypop.com/blogstats?q='+QURL, 'daypop.png', 'Link statistics for this weblog via DayPop.')

        #print make_li_button('http://diveintomark.org/newdoor/recommend.cgi?url='+QURL, 'newdoor.png', 'Similar weblogs you may not be reading.')
        #print make_li_button('http://diveintomark.org/newdoor/recommend.cgi?url='+QURL+'?fullroll=1', 'newdoor.png', 'Similar weblogs you may not be reading.')
        print make_li_button('http://www.blogstreet.com/blogsqlbin/home.cgi?url='+QURL, 'blogstreet.png', 'BlogStreet')
        print '</ul>' # '</div>'

    if SITEMETER_ID:
        print '''<div class="nobox">\
<script type="text/javascript" language="JavaScript">var g_leavenoscript=true</script>
<!--WEBBOT bot="HTMLMarkup" startspan ALT="Site Meter" -->
<script type="text/javascript" language="JavaScript">var site="%s"</script>
<script type="text/javascript" language="JavaScript1.2" src="http://%s/js/counter.js?site=%s">
</script>
<noscript>
<a href="http://%s/stats.asp?site=%s" target="_top">
<img src="http://%s/meter.asp?site=%s" alt="Site Meter" border=0></a>
</noscript>
<!-- Copyright (c)2002 Site Meter -->
<!--WEBBOT bot="HTMLMarkup" Endspan --></div>''' % (SITEMETER_ID, SITEMETER_HOST, SITEMETER_ID, SITEMETER_HOST, SITEMETER_ID, SITEMETER_HOST, SITEMETER_ID)

    print '</div>'

def format_entry(entry, tbinfo, topiclist, showfull=False, daymode=False):
    if SHOW_DAY_HEADERS:
        entryid, title, body, extended, author, authorid, date, authoremail, lastmod, rawdate, rawmod, fday, today = entry
    else:
        entryid, title, body, extended, author, authorid, date, authoremail, lastmod, rawdate, rawmod, today = entry
    print '<div class="blog-entry" id="entry-%d">' % entryid
    print '<!--'
    print '<rdf:RDF xmlns="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/">'
    if daymode:
        plink = make_daily_permalink(entryid, today)
    else:
        plink = make_entry_permalink(entryid, today)

    print '<rdf:Description rdf:about="%s" dc:identifier="%s" dc:title="%s" trackback:ping="%s" />' % (plink, plink, cgi.escape(title, 1), make_tblink(entryid))
    print '</rdf:RDF>'
    print '-->'
    plink = make_permalink(entryid, today)
    if LINKTITLE:
        print '<h3 class="blog-header"><a class="author-%d" href="%s" title="Permalink to this entry.">%s</a></h3>' % (authorid, plink, title)
    else:
        print '<h3 class="blog-header"><span class="author-%d">%s</span></h3>' % (authorid, title)
    print '<div class="blog-content"><meta name="QSM.item.start" content="'
    print 'DC.Creator: %s' % cgi.escape(author, 1)
    print 'DC.Identifier:', make_permalink(entryid)
    print 'DC.Identifier.Anchor: %d' % entryid
    print 'DC.Date.Created: %s' % iso_str(rawdate)
    print 'DC.Date.Modified: %s' % iso_str(rawmod)
    print 'DC.Title: %s' % cgi.escape(title, 1)
    if not extended:
        print '" />%s<meta name="QSM.item.end" /></div>' % body
    elif showfull:
        print '" />%s<div id="extended-%d">%s</div><meta name="QSM.item.end" /></div>' % (body, entryid, extended)
    else:
        print '" />%s<div id="extended-%d" style="display: none">%s<meta name="QSM.item.end" /><div><a class="morelink" href="javascript:showhide(\'extended-%d\');showhide(\'readmore-%d\')">&laquo; All done!</a></div></div>' % (body, entryid, extended, entryid, entryid)
        print '<div id="readmore-%d"><a class="morelink" href="javascript:showhide(\'extended-%d\');showhide(\'readmore-%d\')">Read more&hellip; &raquo;</a></div>' % (entryid, entryid, entryid)
        print '</div>'
        #print '<div style="display: none" class="blog-retract"><a href="#extended-%d">&laquo; Hide full entry</a></div>'
        
    print '<div class="blog-footer">'
    print '<span class="blog-alt-permalink"><a title="Alternate permalink for this entry" href="%s">#</a></span>'% make_other_permalink(entryid, today)
    print '<span class="blog-author">By <a class="author-%d" href="%s?author=%s" title="%s">%s</a></span> @' % (authorid, URL, authorid, cgi.escape(authoremail, 1), author)

    if lastmod == date:
        print '<a href="%s" class="blog-date">%s' % (plink, date)
    else:
        print '<a href="%s" class="blog-date-updated" title="Originally posted: %s">%s' % (plink, cgi.escape(date, 1), lastmod)
    print '<img src="%s" alt="[Permalink]" title="Permanent link to this entry" width="13" height="9" /></a>' % LINKURL

    if topiclist:
        topiclinks = '/'.join([
            '<a href="%s?topic=%d" title="%s">%s</a>' %
            (URL, topic, cgi.escape(topicdesc, 1), topicname) for
            (topic, topicname, topicdesc) in topiclist ])
        print '<span class="blog-topic">('+topiclinks+')</span>'
    
    if tbinfo:
        print '<span class="blog-trackback-count"><a href="%s?__mode=view" title="TrackBack (who is linking to this entry)">&laquo;&nbsp;(%d)</a></span>' % (make_tblink(entryid), len(tbinfo))
    else:
        print '<span class="blog-trackback"><a href="%s?__mode=view" title="TrackBack (who is linking to this entry)">&laquo;&nbsp;(0)</a></span>' % make_tblink(entryid)
    if TTURL:
        print '<a href="http://www.blogmatrix.com/blogtrack?url=%s&amp;entry-url=%d"><span class="tt" id="tt-%d" title="BlogThread (discussions of this entry and included links)">&raquo;</span></a>' % (QURL, entryid, entryid)
    if SHOW_EDIT_LINK:
        print '<span class="blog-edit"><a href="%s?entryid=%d">[Edit]</a></span>' % (EDITURL, entryid)
    if COSMOS_LINK:
        print '<span class="blog-cosmos"><a class="technorati" href="http://www.technorati.com/cosmos/links.html?url=%s" title="Other blogs that linked to this entry.">[Cosmos]</a></span>' % urllib.quote(plink)
    if INLINE_TRACKBACK and tbinfo:
        print '<div class="blog-trackback-entries" id="trackback-%d"><ul class="nav">' % entryid
        for tb in tbinfo:
            print '<li>&raquo; %s linked with <a title="%s" href="%s">%s</a>'%(
                cgi.escape(tb['blog_name'] or 'Someone'),
                cgi.escape(tb['excerpt'] or '', 1),
                cgi.escape(tb['url'], 1),
                cgi.escape(tb['title'] or '(untitled)'))
            if INLINE_TRACKBACK_TIMES:
                print '@ %s' % cgi.escape(tb['added'])
            print '</li>'
        print '</ul></div>'
    print '</div>'
    print '</div>'

def generate_entries(entries, tbinfo, topicmap, cookies, now, daymode, plain):
    print '<div class="blog-entries">'
    full = (len(entries) < FULL_THRESHOLD)
    lastday = ''
    if SHOW_DAY_HEADERS:
        for entry in entries:
            fday = entry.fields.fday
            if lastday != fday:
                print '<h2 class="dayheader">%s</h2>' % fday
                lastday = fday
            eid = entry.fields.entryid
            format_entry(entry, tbinfo.get(eid), topicmap.get(eid, []), full,
                         daymode)
    else:
        for entry in entries:
            eid = entry.fields.entryid
            format_entry(entry, tbinfo.get(eid), topicmap.get(eid, []), full,
                         daymode)

    t = end_timing()
    total = sum(t)
    print '<div class="pagebottom">Page generated at %s in %.2f seconds (%.2f user, %.2f system).' % (now, total, t[0], t[1])
    if not cookies:
        print '<a href="%s">Need a cookie?</a>' % CONFIGURL
    print '</div>'
    print '</div>'

def safe_int(value, default=0):
    if value:
        try:
            return int(value)
        except:
            return default
    return default

TBQUERY=('''SELECT title, url, excerpt, blog_name,
      to_char(added, %(DATEFMT)s) AS added FROM trackback WHERE
      entryid=%%d ORDER BY trackback.added DESC''') % blog_config.__dict__
FQUERYSTR=("""\
c.entryid, c.title, c.body, c.extended, a.authorname,
c.author, to_char(c.date, %(DATEFMT)s) AS fdate, a.authoremail,
to_char(c.lastmod, %(DATEFMT)s) AS flastmod, c.date, c.lastmod,
to_char(c.date AT TIME ZONE 'UTC', 'YYYYMMDD') AS today
""") % blog_config.__dict__
if SHOW_DAY_HEADERS:
    QUERYSTR=("""\
c.entryid, c.title, c.body, c.extended, a.authorname,
c.author, to_char(c.date, %(BRIEFDATEFMT)s) AS fdate, a.authoremail,
to_char(c.lastmod,
  CASE WHEN date_trunc('day', c.lastmod) = date_trunc('day', c.date)
  THEN %(BRIEFDATEFMT)s ELSE %(DATEFMT)s END) AS flastmod,
c.date, c.lastmod, to_char(c.date, %(DAYFMT)s) AS fday,
to_char(c.date AT TIME ZONE 'UTC', 'YYYYMMDD') AS today
""") % blog_config.__dict__
else:
    QUERYSTR=FQUERYSTR

def generate_page(req=None, localref=False, cookies=None, topic=None,
                  author=None, limit=None, offset=None, entryid=None, day=None,
                  start=None, month=None, force_refresh=False, ims=None,
                  overview=False, fullroll=None, plain=False, **args):
    cookies = cookies or {}
    try:
        db = psycopg.connect(blog_config.DSN)
        db.commit()
    except:
        return failed_query('Database is currently down; please try again in a few minutes.', req=req)

    if req:
        pathinfo = req.path_info
    else:
        pathinfo = os.environ.get('PATH_INFO', None)

    if pathinfo:
        m = re.match(pathinfo, r'/(\d+)$')
        if m:
           entryid = m.group(1)
        else:
            m = re.match(pathinfo, r'/day=(\d+)$', re.I)
            if m:
                day = m.group(1)
            else:
                m = re.match(pathinfo, r'/month=(\d+)$', re.I)
                if m:
                    month = m.group(1)

    queries = []
    if topic:
        try:
            topic = int(topic)
        except:
            return failed_query('Invalid topic ID.', req=req)

    if author:
        try:
            author = int(author)
            queries.append("c.author=%d" % author)
        except:
            return failed_query('Invalid author ID.', req=req)

    limit = safe_int(limit)
    if not limit:
        if cookies.has_key('limit'):
            limit = safe_int(cookies['limit'].value, blog_config.DEFLIMIT)
        else:
            limit = blog_config.DEFLIMIT
    # Make sure limit is in [1, 50]
    limit = min(max(1, limit), 50)

    offset = safe_int(offset)
    # Make sure the offset >=0
    offset = max(offset or 0, 0)

    order = 'DESC'
    if entryid:
        if not isinstance(entryid, (tuple, list)):
            entryid = [entryid]
        entries = [x for x in entryid if x.isdigit()]
        if entries:
            queries.append('c.entryid IN (%s)' % (','.join(entries)))
            order = 'ASC'
    elif start:
        try:
            queries.append('c.entryid <= %d' % int(start))
        except:
            pass

    dates = None
    daymode = False
    if day:
        try:
            day = int(day)
            y, m = divmod(day, 10000)
            m, d = divmod(m, 100)
            basedate = DateTime.Date(y, m, d)
            dates = [basedate + DateTime.oneDay, basedate - DateTime.oneDay]
            if dates[0] > DateTime.gmt():
                dates[0] = None
            queries.extend(
                ["extract(YEAR FROM c.date AT TIME ZONE 'UTC')=%d" % y,
                 "extract(MONTH FROM c.date AT TIME ZONE 'UTC')=%d" % m,
                 "extract(DAY FROM c.date AT TIME ZONE 'UTC')=%d" % d])
            limit = None
            daymode = True
        except:
            pass
    elif month:
        try:
            month = int(month)
            y, m = divmod(month, 100)
            queries.extend(['extract(YEAR FROM c.date)=%d' % y,
                            'extract(MONTH FROM c.date)=%d' % m])
            if FULL_MONTH_ARCHIVES:
                limit = None
        except:
            month = None

    frontpage = not queries and not topic
    if frontpage:
        dates = [None, DateTime.gmt() - DateTime.oneDay]
        
    distinct = 'ALL'
    distorder = 'c.pinned DESC, c.date '+order
    basequeries = ['c.visible']

    queries.extend(basequeries)

    if topic:
        queries.extend(['topicmap.topic=%d' % topic,
                        'topicmap.entryid=c.entryid'])

    query = ' AND '.join(queries)

    cursor = db.cursor()
    cursor.execute("SET TIME ZONE 'UTC'")
    cursor.execute("SELECT %s c.entryid FROM "
                   "content c INNER JOIN authors a USING (author) "
                   "WHERE %s ORDER BY %s" % (distinct, query, distorder))
    count = cursor.rowcount

    cursor.execute("SELECT MAX(date_trunc('second', c.lastmod)),"
                   "MAX(date_trunc('second', c.date)) FROM content c")
    latest, ldate = cursor.fetchone()
    if dates and ldate:
        if dates[0] > ldate:
            dates[0] = None
        dates[1] = min(dates[1], ldate - DateTime.oneDay)

    cursor.execute("SELECT MAX(date_trunc('second', added)) FROM trackback")
    latest = max(latest, cursor.fetchone()[0])

    if frontpage:
        cursor.execute("SELECT MAX(updated) FROM blogroll")
        latest = max(latest, cursor.fetchone()[0])
    
    expires = DateTime.gmt()+(DateTime.oneMinute*blog_config.TTL)
    if latest:
        extras = [ ('Last-Modified', DateTime.ARPA.strGMT(latest)),
                   ]
    else:
        extras = []

    if force_refresh:
        extras.extend( [('Cache-Control', 'no-cache'),
                        ('Expires', DateTime.ARPA.strGMT(latest))
                        ])
    else:
        extras.append( ('Expires', DateTime.ARPA.strGMT(expires)) )

    if ims:
        ims = DateTime.ARPA.ParseDateTimeGMT(ims)
        if not force_refresh and latest <= ims:
            return 304

    cursor.execute('SELECT topic, topicname, topicdesc FROM topics ORDER BY topicname')
    topics = cursor.fetchall()
    topicinfo = dict([(t, (tname, tdesc)) for (t, tname, tdesc) in topics])

    try:
        tz = _tzfilter.sub('', cookies['timezone'].value)
    except:
        tz = blog_config.TIMEZONE

    try:
        blogroll_mode = cookies['blogroll'].value
    except:
        blogroll_mode = 'date'

    try:
        cursor.execute("SET TIME ZONE '%s'" % tz)
    except:
        cursor.execute("SET TIME ZONE '%s'" % blog_config.TIMEZONE)

    if fullroll is not None:
        shortroll = not safe_int(fullroll)
    else:
        try:
            shortroll = not safe_int(cookies['fullroll'].value)
        except:
            shortroll = True

    if limit:
        limitstr = 'LIMIT %d OFFSET %d' % (limit, offset)
    else:
        limitstr = 'OFFSET %d' % offset

    cursor.execute("SELECT %s %s FROM content c INNER JOIN authors a "
                   "USING (author) WHERE %s ORDER BY %s %s" % (
        distinct, QUERYSTR, query, distorder, limitstr))
    R = db_row.MetaRow(cursor.description)
    entries = [R(row) for row in cursor.fetchall()]
    eidlist = [entry[0] for entry in entries]
    fulleidlist = list(eidlist)
    eids = ', '.join([str(x) for x in eidlist])

    if eids:
        queries = basequeries + [('entryid NOT IN (%s)' % eids)]
    else:
        queries = basequeries
    query = ' AND '.join(queries)
    cursor.execute(
        "SELECT %s FROM content c INNER JOIN authors a USING (author) "
        "WHERE %s ORDER BY c.lastmod DESC LIMIT %d" % (
        FQUERYSTR, query, blog_config.UPDATED) )
    R = db_row.MetaRow(cursor.description)
    recent = [R(row) for row in cursor.fetchall()]
    fulleidlist += [x[0] for x in recent]

    cursor.execute(
        "SELECT %s FROM content c INNER JOIN authors a USING (author) "
        "WHERE entryid IN (SELECT entryid FROM best) "
        "ORDER BY c.entryid" % FQUERYSTR)
    R = db_row.MetaRow(cursor.description)
    best = [R(row) for row in cursor.fetchall()]
    fulleidlist += [x[0] for x in best]

    tbinfo = {}
    if eidlist:
        for entry in eidlist:
            cursor.execute(TBQUERY % entry)
            R = db_row.MetaRow(cursor.description)
            tbinfo[entry] = [R(row) for row in cursor.fetchall()]

    cursor.execute('SELECT author, authorname FROM authors')
    authors = {}
    for (authorid, authorname) in cursor.fetchall():
        authors[authorid] = authorname

    topicmap = {}
    if fulleidlist:
        for entry in eidlist:
            cursor.execute('SELECT topicmap.topic, topicname, topicdesc '
                           'FROM topicmap INNER JOIN topics USING (topic) '
                           'WHERE entryid=%d ORDER BY topicname' % entry)
            R = db_row.MetaRow(cursor.description)
            topicmap[entry] = [R(row) for row in cursor.fetchall()]

    if blogroll_mode == 'alpha':
        blogroll_order = 'lower(name)'
    else:
        blogroll_order = 'blogroll.updated DESC, lower(name)'

    blogroll_where = ''
    if HIDE_BLOGROLL_ENTRY_AFTER and shortroll:
        blogroll_where = "WHERE AGE(NOW(), updated) < INTERVAL '%s'" % HIDE_BLOGROLL_ENTRY_AFTER

    cursor.execute("SELECT name, url, comment, rssurl, (CASE WHEN AGE(NOW(), updated) < INTERVAL '1 year' THEN to_char(updated, %s) ELSE NULL END) AS updated, (AGE(NOW(), updated) < INTERVAL '%s') AS new FROM blogroll %s ORDER BY %s" % (blog_config.DATEFMT, blog_config.NEWNESS, blogroll_where, blogroll_order))
    R = db_row.MetaRow(cursor.description)
    blogroll = [R(row) for row in cursor.fetchall()]

    cursor.execute('SELECT to_char(NOW(), %s)' % blog_config.DATEFMT)
    now = cursor.fetchone()[0]

    cursor.execute("SET TIME ZONE '%s'" % blog_config.TIMEZONE)
    cursor.execute(
        "SELECT to_char(date_trunc('month', date), %s), count(*), "
        "to_char(date_trunc('month', date), 'YYYYMM') "
        "FROM content GROUP BY date_trunc('month', date) ORDER BY "
        "date_trunc('month', date) DESC" % blog_config.MONTHFMT)
    months = cursor.fetchall()

    cosmos = None
    if blog_config.TECHNORATI_API_KEY:
        cursor.execute('SELECT * FROM cosmos ORDER BY '
                       'inboundblogs, inboundlinks')
        R = db_row.MetaRow(cursor.description)
        cosmos = [R(row) for row in cursor.fetchall()]

    try:
        style = cookies['style'].value
    except:
        style = blog_config.DEF_STYLESHEET

    if len(entries) == 1:
        title = '%s: %s' % (blog_config.BLOG_TITLE, entries[0].fields.title)
    else:
        title = '%s: %s' % (blog_config.BLOG_TITLE, blog_config.BLOG_DESC)

    header(title, extra_headers=extras, req=req, front=True,
           use_style=style, latest=latest)
    generate_blogtop(plain)
    if not plain:
        generate_sidebar(entries, topics, (not frontpage), offset, limit,
                         count, (not localref), author, topic, recent, month,
                         months, start=start, use_style=style, tz=tz,
                         overview=overview, best=best, blogroll=blogroll,
                         dates=dates, cosmos=cosmos, topicmap=topicmap,
                         shortroll=shortroll, cookies=cookies, now=now,
                         authors=authors)
    generate_entries(entries, tbinfo, topicmap, cookies, now, daymode, plain)
    footer()

    lav = os.getloadavg()
    print '<!-- Load average: %s -->' % (', '.join([str(x) for x in lav]))
    
##     if ims:
##         print '<!-- %s %s -->' % (iso_str(ims), iso_str(latest))
##     print '<!-- %s -->' % tz
##     print '<!-- %s -->' % pathinfo
