# A thoroughly lame weblog
# (C) 2002-03 Chris Lawrence

import sys
import cgi
import psycopg
import re
import cStringIO
import blog
import db_row
import urlparse
from mx import DateTime

def iso_str(date, local=False):
    if local:
        date = DateTime.ISO.str(date.localtime()).replace(' ', 'T')
    else:
        date = DateTime.ISO.strUTC(date).replace(' ', 'T')
    
    if date.endswith('+0000'):
        return date[:-5]+'Z'
    return date[:-2]+':'+date[-2:]

def make_taguri(entry):
    return 'tag:%s,%s:%d' % (
        blog.HOSTURL, DateTime.ISO.strUTC(entry.fields.date).split()[0],
        entry.fields.entryid)

def protect_cdata(cdata):
    if cdata.find(']]') >= 0:
        return cgi.escape(cdata)
    else:
        return '<![CDATA[%s]]>' % cdata

def header(extra_headers=[], req=None, atom=False):
    if atom:
        ctype = 'application/atom+xml; charset=utf-8'
    else:
        ctype = 'text/xml; charset=utf-8'
    
    if req:
        req.content_type = 'text/xml; charset=utf-8'
        #ctype
        for (header, content) in extra_headers:
            req.headers_out.add(header, content)
    else:
        print 'Content-Type:', ctype
        for (header, content) in extra_headers:
            print '%s: %s' % (header, content)
        print
    print '<?xml version="1.0" encoding="utf-8"?>'

def rss_feed_2(entries, latest, full, topicmap):
    lmt = DateTime.ARPA.strGMT(latest)
    print '<rss version="2.0" xmlns:content="http://purl.org/rss/1.0/modules/content/" xmlns:cc="http://web.resource.org/cc/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:dcterms="http://purl.org/dc/terms/" ><channel>'
    if full:
        print ' <title>%s (Full feed)</title>' % cgi.escape(blog.BLOG_TITLE)
    else:
        print ' <title>%s (Mixed feed)</title>' % cgi.escape(blog.BLOG_TITLE)
    print ' <link>%s</link>' % blog.URL
    print ' <description>%s</description>' % blog.BLOG_LONGDESC_STRIPPED
    print ' <language>%s</language>' % blog.LANG
    print ' <webMaster>%s</webMaster>' % blog.MAILTO
    print ' <managingEditor>%s</managingEditor>' % blog.MAILTO
    print ' <generator>%s</generator>' % blog.LS_BLOG_VERSION
    print ' <lastBuildDate>%s</lastBuildDate>' % cgi.escape(lmt)
    print ' <docs>http://backend.userland.com/rss</docs>'
    print ' <ttl>%d</ttl>' % blog.TTL
    if blog.CCLICENSE:
        print ' <cc:license rdf:resource="%s" />' % blog.CCLICENSE
    for entry in entries:
        body = entry.fields.body
        escbody = protect_cdata(body)
        
        if full:
            abbrcontent = escbody
        elif entry.fields.excerpt:
            abbrcontent = blog.escape_nonascii(entry.fields.excerpt)
        else:
            abbrcontent = blog.escape(body)
        title = blog.escape(entry.fields.title)
        frontlink = blog.make_frontlink(entry['entryid'])
        permalink = blog.make_permalink(entry['entryid'], entry['today'])
        print ' <item>\n  <title>%s</title>\n  <description>%s</description>\n  <link>%s</link>\n  <pubDate>%s</pubDate>\n  <guid isPermaLink="true">%s</guid>' % (title, abbrcontent, cgi.escape(frontlink), cgi.escape(DateTime.ARPA.strGMT(entry['date'])), cgi.escape(permalink))
        #print '  <dc:date>%s</dc:date>' % iso_str(entry['date'])
        print '  <dcterms:modified>%s</dcterms:modified>' % iso_str(entry['lastmod'])
        #print '  <dc:subject>%s</dc:subject>' % cgi.escape(entry['topicname'])
        print '  <dc:creator>%s</dc:creator>' % cgi.escape(entry['authorname'])
        if not full:
            print '  <content:encoded>%s</content:encoded>' % escbody
        for (topic, tname, odtopic) in topicmap.get(entry.fields.entryid, []):
            print '  <category>%s</category>' % cgi.escape(tname)
            if odtopic:
                print '  <category domain="http://dmoz.org/">%s</category>' % cgi.escape(odtopic)
        print ' </item>'
    print ' </channel></rss>'

def rss_feed_1(entries, latest, full, topicmap):
    eurls = {}
    lmt = iso_str(latest)
    print '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:content="http://purl.org/rss/1.0/modules/content/" xmlns:dcterms="http://purl.org/dc/terms/" xmlns:cc="http://web.resource.org/cc/" xmlns="http://purl.org/rss/1.0/">'
    print '<channel rdf:about="%s">' % cgi.escape(blog.URL, 1)
    print ' <title>%s (RSS 1.0 feed)</title>' % cgi.escape(blog.BLOG_TITLE)
    print ' <link>%s</link>' % blog.URL
    print ' <description>%s</description>' % blog.BLOG_LONGDESC_STRIPPED
    print ' <dc:creator>%s</dc:creator>' % blog.MAILTO
    print ' <dc:date>%s</dc:date>' % lmt
    print ' <dc:language>%s</dc:language>' % blog.LANG
    if blog.CCLICENSE:
        print ' <cc:license rdf:resource="%s" />' % blog.CCLICENSE
    print ' <items><rdf:Seq>'
    for entry in entries:
        eurl = eurls[entry['entryid']] = blog.make_permalink(
            entry['entryid'], entry['today'])
        print '  <rdf:li resource="%s" />' % cgi.escape(eurl, 1)
    print ' </rdf:Seq></items>'
    print '</channel>'
    for entry in entries:
        eurl = eurls[entry['entryid']]
        print ' <item rdf:about="%s">' % cgi.escape(eurl, 1)
        title = blog.make_excerpt(entry['title'], truncate=False)
        print '  <title>%s</title>' % cgi.escape(title)
        print '  <link>%s</link>' % cgi.escape(eurl)
        body = entry.fields.body
        if entry.fields.excerpt:
            abbrcontent = blog.escape_nonascii(entry.fields.excerpt)
        else:
            abbrcontent = blog.escape(body)
        print '  <description>%s</description>' % abbrcontent
        print '  <content:encoded>%s</content:encoded>' % protect_cdata(body)
        print '  <dc:date>%s</dc:date>' % iso_str(entry['date'])
        print '  <dcterms:modified>%s</dcterms:modified>' % iso_str(entry['lastmod'])
        for (topic, tname, odtopic) in topicmap.get(entry.fields.entryid, []):
            print '  <dc:subject>%s</dc:subject>' % cgi.escape(tname)
        print '  <dc:creator>%s</dc:creator>' % cgi.escape(entry['authorname'])
        print ' </item>'
    print '</rdf:RDF>'

def atom_feed(entries, latest, full, topicmap):
    print '<?xml-stylesheet href="%s" type="text/css"?>' % (
        urlparse.urljoin(blog.CSS, "atom.css"))
    #print '<!-- Prototype feed! -->'
    print '<!-- It would be nice to attach these ent:topic tags to a DMOZ cloud... oh well. -->'
    print '<feed version="0.3" xml:lang="%s" xmlns="http://purl.org/atom/ns#" xmlns:ent="http://www.purl.org/NET/ENT/1.0/" xmlns:cc="http://web.resource.org/cc/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xml:base="%s" >' % (blog.LANG, blog.URL)
    print ' <title>%s</title>' % cgi.escape(blog.BLOG_TITLE)
    print ' <link rel="alternate" type="text/html" href="%s" />' % cgi.escape(blog.URL, 1)
    #print ' <!-- See http://www.intertwingly.net/wiki/pie/SubTitle; for now'
    #print '      the situation is as clear as mud. -->'
    print ' <tagline>%s</tagline>' % blog.escape(blog.BLOG_LONGDESC)
#    print ' <webMaster>%s</webMaster>' % blog.MAILTO
#    print ' <managingEditor>%s</managingEditor>' % blog.MAILTO
#    print ' <generator>%s</generator>' % blog.LS_BLOG_VERSION
    print ' <modified>%s</modified>' % iso_str(latest)
    print '''\
<info type="application/xhtml+xml" mode="xml">
<div xmlns="http://www.w3.org/1999/xhtml">
This is an Atom syndication feed. It is intended to be viewed in a news aggregator or syndicated to another site.  Please visit the <a href="http://intertwingly.net/wiki/pie/">Atom Project</a> for more information.
</div></info>'''

    print ' <generator url="%s" version="%s">%s</generator>' % (
        blog.LS_BLOG_URL, blog.LS_BLOG_VERSION_NUMBER, blog.LS_BLOG)
    print ' <copyright>Copyright &#169; %s %s.</copyright>'  % (
        blog.escape(blog.CYEAR), blog.escape(blog.FULL_OWNER))
    if blog.CCLICENSE:
        print ' <cc:license rdf:resource="%s" />' % blog.CCLICENSE
    for entry in entries:
        print ' <entry>'
        title = blog.escape(entry.fields.title)
        print '  <title>%s</title>' % title
        print '  <link rel="alternate" type="text/html" href="%s" />' % \
              cgi.escape(blog.make_permalink(entry.fields.entryid, entry.fields.today), 1)
        # The ID should always be the entry permalink
        print '  <id>%s</id>' % make_taguri(entry)
        #blog.make_entry_permalink(entry.fields.entryid,
        #                                                  entry.fields.today)
        cdate = iso_str(entry.fields.date)
        print '  <created>%s</created>' % cdate
        print '  <issued>%s</issued>' % cdate
        print '  <modified>%s</modified>' % iso_str(entry.fields.lastmod)
        print '  <author>'
        print '   <name>%s</name>' % cgi.escape(entry.fields.authorname)
        print '   <email>%s</email>' % cgi.escape(entry.fields.authoremail)
        #print '   <url>%s?author=%d</url>' % (blog.URL, entry.fields.author)
        print '   <url>%s</url>' % cgi.escape(entry.fields.authorurl)
        print '  </author>'
        excerpt = entry.fields.excerpt
        if excerpt:
            print ' <summary type="text/plain">%s</summary>' % blog.escape_nonascii(excerpt)
            
        body = entry.fields.body
        abbrcontent = blog.escape(body)
        print '  <content type="multipart/alternative">'
        print '   <content type="text/plain">%s</content>' % abbrcontent
        print '   <content type="text/html" mode="escaped">%s</content>' % protect_cdata(body)
        print '  </content>'
        for (topic, tname, odtopic) in topicmap.get(entry.fields.entryid, []):
            if odtopic:
                print '  <ent:topic id="%s" href="http://www.dmoz.org/%s">%s</ent:topic>' % (cgi.escape(odtopic, 1), cgi.escape(odtopic, 1), cgi.escape(tname))
        print ' </entry>'
    print '</feed>'

def rss(full=False, req=None, atom=False, version="2"):
    try:
        full = bool(int(full))
    except:
        full = False

    try:
        version = int(version)
        if version > 2 or version < 1:
            version = 2
    except:
        version = 2

    try:
        atom = bool(int(atom))
    except:
        atom = False

    db = psycopg.connect(blog.DSN)
    db.commit()

    distorder = 'c.date DESC'
    queries = ['a.author=c.author', 'c.visible']
    query = ' AND '.join(queries)

    cursor = db.cursor()
    cursor.execute("SET TIME ZONE 'UTC'")
    cursor.execute("SELECT max(date_trunc('second', c.lastmod)) FROM content c WHERE c.visible")
    count = cursor.rowcount
    if count:
        latest = cursor.fetchone()[0]
    else:
        latest = DateTime.DateTimeFromJDN(0)

    if req:
        from mod_python import apache

        # Handle If-Modified-Since
        ims = req.headers_in.get('If-Modified-Since')
        if ims:
            ims = DateTime.ARPA.ParseDateTimeGMT(ims)
            if latest <= ims:
                raise apache.SERVER_RETURN, apache.HTTP_NOT_MODIFIED

    expires = DateTime.gmt()+(DateTime.oneMinute*blog.TTL)
    lmt = DateTime.ARPA.strGMT(latest)
    extras = [ ('Last-Modified', lmt),
               ('Expires', DateTime.ARPA.strGMT(expires)) ]

    if atom:
        limit = blog.DEFLIMIT
    else:
        limit = blog.RSSLIMIT

    cursor.execute("SELECT c.entryid, c.title, c.date, c.lastmod, a.author, a.authoremail, a.authorname, a.authorurl, c.body, c.excerpt, to_char(c.date AT TIME ZONE 'UTC', 'YYYYMMDD') AS today FROM content c, authors a WHERE %s ORDER BY %s LIMIT %d" % (query, distorder, limit))
    R = db_row.MetaRow(cursor.description)
    entries = [R(row) for row in cursor.fetchall()]

    topicmap = {}
    for entry in entries:
        eid = entry[0]
        cursor.execute('SELECT topicmap.topic, topicname, odtopic '
                       'FROM topicmap, topics WHERE '
                       'topicmap.topic=topics.topic AND entryid=%d' % eid)
        R = db_row.MetaRow(cursor.description)
        topicmap[eid] = [R(row) for row in cursor.fetchall()]

    header(extra_headers=extras, req=req, atom=atom)
    if atom:
        atom_feed(entries, latest, full, topicmap)
    elif version == 1:
        rss_feed_1(entries, latest, full, topicmap)
    else:
        rss_feed_2(entries, latest, full, topicmap)

def index(req, full=False, version='2', atom=False):
    out, newout = sys.stdout, cStringIO.StringIO()
    sys.stdout = newout

    #ims = req.headers_in.get('If-Modified-Since')
    try:
        rss(full=full, req=req, version=version, atom=atom)
        return newout.getvalue()
    finally:
        sys.stdout = out
